#!/usr/bin/webif-page
<?

###
 #
 # FreeWLAN Addons - http://www.freewlan.info
 #
 # This Script is based on work from http://www.fonfan.de
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
 # as published by the Free Software Foundation; either version 2
 # of the License, or (at your option) any later version.
 #
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 # GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 # MA  02110-1301, USA
 #
 # http://www.gnu.org/copyleft/gpl.html
 #
###

. /usr/lib/webif/webif.sh

config_load router
config_get mode mode mode
config_get ssid mode ssid
config_get rssid mode rssid

config_load fon
. /tmp/network-config

get_default wanmode wan mode
case "$FORM_wanmode" in
	static)
		wanmode="Static"
	;;
	dhcp)
		wanmode="DHCP"
	;;
	pppoe)
		wanmode="PPPoE"
	;;
	pptp)
		wanmode="PPTP"
	;;
	*) wanmode="Unknown";;
esac

config_get pubssid public essid
config_get privssid private essid
config_get encryption private encryption
config_get priv_hidden private hidden

if [ "$priv_hidden" = "1" ]; then
	priv_hidden="<span style=\"color: green\">@TR<<Hidden>></span>"
else
	priv_hidden=""
fi

wan_gw="$(route -n | grep '^0.0.0.0' | awk '{print $2}')"
for ns in $(grep nameserver /etc/resolv.conf | awk '{print $2}'); do
	wan_ns="${wan_ns:+$wan_ns, }$ns"
done

version="$(cat /etc/fon_version) r$(cat /etc/fon_revision)"
addonversion="$(cat /etc/addon_version)"

header "Router Status - Freewlan Addons $addonversion"

case "$mode" in
	1) pub_mac="$(ifconfig ath0 2>/dev/null | grep HWaddr | awk -F'[ ]+' '{print $5}')"
priv_ip="$(ifconfig ath1 2>/dev/null | grep inet | awk -F'[: ]+' '{print $4}')"
priv_mac="$(ifconfig ath1 2>/dev/null | grep HWaddr | awk -F'[ ]+' '{print $5}')"
wan_mac="$(ifconfig eth0 2>/dev/null | grep HWaddr | awk -F'[ ]+' '{print $5}')"
wan_ip="$(ifconfig "${wan_ifname:-eth0}" 2>/dev/null | grep inet | awk -F'[: ]+' '{print $4}')"
cat <<EOF
		<table width="90%">
		<tr><td colspan="2"><p><strong>@TR<<Router acts as access point>></strong></p></td></tr>
		<tr><td colspan="2"><p><hr /></p></td></tr>

		<tr><td colspan="2"><p><strong>@TR<<Status_Conn_Priv#Active connections on the private WLAN>></strong></p></td></tr>
		<tr><td colspan="2">$conn_priv
EOF
wlanconfig ath1 list 2> /dev/null | grep -v ADDR| while read i
		do
			mac=`echo $i | awk '{print $1}'`
			speed=`echo $i | awk '{print $4}'`
			ip=`cat /proc/net/arp | grep -i $mac | awk '{print $1}'`
			echo "MAC: $mac IP: $ip @TR<<Speed>>: $speed<br />"
		done
cat <<EOF
		</td></tr>
		<tr><td colspan="2"><p><hr /></p></td></tr>
		
		<tr><td colspan="2"><p><strong>@TR<<Status_Conn_Pub#Active connections on the public WLAN>></strong></p></td></tr>
		<tr><td colspan="2">
EOF
wlanconfig ath0 list 2> /dev/null | grep -v ADDR| while read i
		do
			mac=`echo $i | awk '{print $1}'`
			speed=`echo $i | awk '{print $4}'`
			ip=`cat /proc/net/arp | grep -i $mac | awk '{print $1}'`
			echo "MAC: $mac IP: $ip @TR<<Speed>>: $speed<br />"
		done
cat <<EOF
		</td></tr>
		<tr><td colspan="2"><p><hr /></p></td></tr>

		<tr><td colspan="2"><p><strong>@TR<<Configuration summary>></strong></p></td></tr>
		<tr><td>@TR<<Firmware Version>></td><td>$version</td></tr>
		<tr><td>@TR<<Addon Version>></td><td>$addonversion</td></tr>
		<tr><td colspan="2"><p><hr /></p></td></tr>

		<tr><td colspan="2"><p><strong>@TR<<Internet connection>></strong></p></td></tr>
		<tr><td>@TR<<Connection type>></td><td>$wanmode</td></tr>
		<tr><td>@TR<<MAC Address>></td><td>$wan_mac</td></tr>
		<tr><td>@TR<<IP Address>></td><td>${wan_ip:-N/A}</td></tr>
		<tr><td>@TR<<Gateway Address>></td><td>${wan_gw:-N/A}</td></tr>
		<tr><td>@TR<<DNS Server>></td><td>${wan_ns:-N/A}</td></tr>
		<tr><td colspan="2"><p><hr /></p></td></tr>

		<tr><td colspan="2"><p><strong>@TR<<WiFi Settings>></strong></p></td></tr>
		<tr><td>@TR<<Public SSID>></td><td>FON_$pubssid</td></tr>
		<tr><td>@TR<<Public MAC>></td><td>$pub_mac</td></tr>
		<tr><td>@TR<<Private SSID>></td><td>$privssid $priv_hidden</td></tr>
		<tr><td>@TR<<Private MAC>></td><td>$priv_mac</td></tr>
		<tr><td>@TR<<Encryption>></td><td>${encryption:-none}</td></tr>
		<tr><td>@TR<<IP Address>></td><td>${priv_ip:-N/A}</td></tr>
		</table>
EOF
;;

	2) ath0_pwr="$(iwconfig ath0 2>/dev/null | grep Bit | awk 'FS=":" {print $2}' | awk '{print $1}')" 
pub_mac="$(ifconfig ath2 2>/dev/null | grep HWaddr | awk -F'[ ]+' '{print $5}')"
bridge_ip="$(ifconfig ath0 2>/dev/null | grep inet | awk -F'[: ]+' '{print $4}')"
cat <<EOF
		<table width="90%">
		<tr><td colspan="2"><p><strong>@TR<<Router acts as repeater>></strong></p></td></tr>
		<tr><td colspan="2"><p><hr /></p></td></tr>

		<tr><td colspan="2"><p><strong>@TR<<Status_Conn_Pub#Active connections on the public WLAN>></strong></p></td></tr>
		<tr><td colspan="2">
EOF
wlanconfig ath2 list 2> /dev/null | grep -v ADDR| while read i
		do
			mac=`echo $i | awk '{print $1}'`
			speed=`echo $i | awk '{print $4}'`
			ip=`cat /proc/net/arp | grep -i $mac | awk '{print $1}'`
			echo "MAC: $mac IP: $ip @TR<<Speed>>: $speed<br />"
		done
cat <<EOF
		</td></tr>
		<tr><td colspan="2"><p><hr /></p></td></tr>

		<tr><td colspan="2"><p><strong>@TR<<Configuration summary>></strong></p></td></tr>
		<tr><td>@TR<<Firmware Version>></td><td>$version</td></tr>
		<tr><td>@TR<<Addon Version>></td><td>$addonversion</td></tr>
		<tr><td colspan="2"><p><hr /></p></td></tr>

		<tr><td colspan="2"><p><strong>@TR<<Host connection>></strong></p></td></tr>
		<tr><td>@TR<<Remote SSID>></td><td>$rssid</td></tr>
		<tr><td>@TR<<IP Address>></td><td>${bridge_ip:-N/A}</td></tr>
		<tr><td>@TR<<Gateway Address>></td><td>${wan_gw:-N/A}</td></tr>
		<tr><td>@TR<<DNS Server>></td><td>${wan_ns:-N/A}</td></tr>
		<tr><td>@TR<<Signal strength>></td><td>$ath0_pwr M</td></tr>
		<tr><td colspan="2"><p><hr /></p></td></tr>

		<tr><td colspan="2"><p><strong>@TR<<WiFi Settings>></strong></p></td></tr>
		<tr><td>@TR<<Public SSID>></td><td>FON_$ssid</td></tr>
		<tr><td>@TR<<Public MAC>></td><td>$pub_mac</td></tr>
		</table>
EOF
;;

esac

footer ?>