#!/usr/bin/webif-page
<?

###
 #
 # FreeWLAN Addons - http://www.freewlan.info
 #
 # This Script is based on work from http://www.fonfan.de
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
 # as published by the Free Software Foundation; either version 2
 # of the License, or (at your option) any later version.
 #
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 # GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 # MA  02110-1301, USA
 #
 # http://www.gnu.org/copyleft/gpl.html
 #
###

. /usr/lib/webif/webif.sh

validate <<EOF
string|FORM_submit|@TR<<Submit>>|max=10|$FORM_submit
EOF

if [ "$?" != "0" ]
then
	FORM_submit=""
fi

load_settings fon
get_default wan wan mode

load_settings router
get_default oldwan mode oldwan

if empty "$FORM_submit"; then
	get_default mode mode mode
	get_default rssid mode rssid
	get_default enc mode enc
	get_default key mode key
	get_default dhcp mode dhcp
	get_default ip mode ip
	get_default netmask mode netmask
	get_default gateway mode gateway
	get_default dns mode dns
	get_default ssid mode ssid
	get_default bridge mode bridge
	get_default oldwan mode oldwan
else
	validate <<EOF
		wpapsk|FORM_key|@TR<<Key>>|$V_K|$FORM_key
		ip|FORM_ip|@TR<<IP Address>>|$V_K|$FORM_ip
		string|FORM_ssid|@TR<<Repeated SSID>>|$V_K max=32|$FORM_ssid
		string|FORM_rssid|@TR<<Remote SSID>>|$V_K max=32|$FORM_rssid
		int|FORM_mode|@TR<<Router mode>>|$V_K min=1 max=2|$FORM_mode
		boolean|FORM_dhcp|@TR<<DHCP>>|$V_K|$FORM_dhcp
		string|FORM_enc|@TR<<Encryption>>|$V_K|$FORM_enc
		netmask|FORM_netmask|@TR<<Netmask>>|$V_K|$FORM_netmask
		ip|FORM_gateway|@TR<<Gateway Adress>>|$V_K|$FORM_gateway
		dns|FORM_dns|@TR<<DNS server>>|$V_K|$FORM_dns
		boolean|FORM_bridge|@TR<<Bridge>>|$V_K|$FORM_bridge
EOF
	equal "$?" 0 && {
		case "$FORM_mode" in
			1)
				load_settings router
				save_setting router mode mode "$FORM_mode"
				commit_settings

				load_settings fon
				save_setting fon wan mode "$FORM_oldwan"
				commit_settings
			;;
			2)
				load_settings router
				save_setting router mode key "$FORM_key"
				save_setting router mode ip "$FORM_ip"
				save_setting router mode ssid "$FORM_ssid"
				save_setting router mode rssid "$FORM_rssid"
				save_setting router mode mode "$FORM_mode"
				save_setting router mode dhcp "$FORM_dhcp"
				save_setting router mode enc "$FORM_enc"
				save_setting router mode netmask "$FORM_netmask"
				save_setting router mode gateway "$FORM_gateway"
				save_setting router mode dns "$FORM_dns"
				save_setting router mode bridge "$FORM_bridge"
				save_setting router mode oldwan "$FORM_wan"

				commit_settings

				load_settings fon
				save_setting fon wan mode "dhcp"
				commit_settings

				#cat /etc/chilli.conf | grep -v dhcpif > /etc/chilli.conf
				#cat /etc/chilli.conf | grep -v radiusnasid > /etc/chilli.conf
				#MAC=$(ifconfig wifi0 | head -n1 | awk '{print $5}'|sed s/:/-/g)
				#echo 'radiusnasid '$MAC >> /etc/chilli.conf
				#echo 'dhcpif ath1' >> /etc/chilli.conf

				if [ "$FORM_enc" == "WPA" ]; then
					echo 'ap_scan=1' > /etc/wpa_supplicant.conf
					echo 'network={' >> /etc/wpa_supplicant.conf
					echo 'ssid="'$FORM_rssid'"' >> /etc/wpa_supplicant.conf
					echo 'scan_ssid=1' >> /etc/wpa_supplicant.conf
					echo 'psk="'$FORM_key'"' >> /etc/wpa_supplicant.conf
					echo 'priority=2' >> /etc/wpa_supplicant.conf
					echo '}' >> /etc/wpa_supplicant.conf
				else
					rm -f /etc/wpa_supplicant.conf
				fi
			;;
		esac
		SAVED=1
	}
fi

header "Router Mode"

cat <<EOF
<script type="text/javascript">
<!--
function modechange() {
	set_visible('mode_ap', isset('mode', '1'));
	set_visible('mode_repeater', isset('mode', '2'));
}
function dhcpchange() {
	set_visible('mode_dhcp', isset('dhcp', '0'));
}
-->
</script>
EOF

display_form <<EOF
	infotable|Advanced_mode#Here you can change the mode the router.

	start_table|0|10|5
		onchange|modechange
		add_row
			add_label_cell|@TR<<Router works as>>
			start_select_cell|mode|$FORM_mode|tableTextSelect
				option|1|@TR<<Access Point>>
				option|2|@TR<<Repeater>>
			end_select_cell
		end_row
	end_table
	start_div|mode_repeater
		start_table|0|10|5
			onchange|dhcpchange
			add_row
				add_label_cell|@TR<<Remote SSID>>
				add_input_cell|rssid|$FORM_rssid|tableTextButton
			end_row
			add_row
				add_label_cell|@TR<<Encryption Type>>
				start_select_cell|enc|$FORM_enc|tableTextSelect
					option|WPA|@TR<<WPA>>
					option|WEP|@TR<<WEP>>
					option|off|@TR<<None>>
				end_select_cell
			end_row
			add_row
				add_label_cell|@TR<<Encryption key>>
				add_input_cell|key|$FORM_key|tableTextButton
			end_row
			add_row
				add_label_cell|@TR<<DHCP>>
				start_select_cell|dhcp|$FORM_dhcp|tableTextSelect
					option|0|@TR<<Disabled>>
					option|1|@TR<<Enabled>>
				end_select_cell
			end_row
		end_table
		start_div|mode_dhcp
			start_table|0|10|5
				add_row
					add_label_cell|@TR<<IP Address>>
					add_input_cell|ip|$FORM_ip|tableTextButton
				end_row
				add_row
					add_label_cell|@TR<<Netmask>>
					add_input_cell|netmask|$FORM_netmask|tableTextButton
				end_row
				add_row
					add_label_cell|@TR<<Gateway>>
					add_input_cell|gateway|$FORM_gateway|tableTextButton
				end_row
				add_row
					add_label_cell|@TR<<DNS server>>
					add_input_cell|dns|$FORM_dns|tableTextButton
				end_row
			end_table
		end_div
		start_table|0|10|5
			add_row
				add_label_cell|@TR<<Local SSID>>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;FON_
				add_input_cell|ssid|$FORM_ssid|tableTextButton
			end_row
			add_row
				add_label_cell|@TR<<Bridge>>
				start_select_cell|bridge|$FORM_bridge|tableTextSelect
					option|1|@TR<<Enabled>>
					option|0|@TR<<Disabled>>
				end_select_cell
			end_row
		end_table
	end_div
	start_table|0|10|5
		add_row
			add_button_cell|submit|@TR<<Submit>>|tableTextButton
		end_row
	end_table
EOF

cat <<EOF
<script type="text/javascript">
<!--
modechange();
dhcpchange();
-->
</script>
EOF

if [ "$SAVED" = "1" ]; then
	echo "<br /><br /><font color=red><b>REBOOTING!!!</b></font>"

	footer

	sleep 5

	reboot
fi

footer ?>
